*** a/src/backend/replication/walreceiver.c
--- b/src/backend/replication/walreceiver.c
***************
*** 324,329 **** WalRcvDie(int code, Datum arg)
--- 324,332 ----
  	/* use volatile pointer to prevent code rearrangement */
  	volatile WalRcvData *walrcv = WalRcv;
  
+ 	/* Ensure that all WAL records received are flushed to disk */
+ 	XLogWalRcvFlush();
+ 
  	SpinLockAcquire(&walrcv->mutex);
  	Assert(walrcv->walRcvState == WALRCV_RUNNING ||
  		   walrcv->walRcvState == WALRCV_STOPPING);